<sqtm-core-customisable-dialog
  [dialogId]="'remote-issue-dialog'"
  [titleKey]="titleKey"
  [attr.data-test-dialog-id]="'remote-issue-dialog'"
>
  <sqtm-core-dialog-body class="flex-row modal-overlay-container">
    @if (shouldShowCacheWarning$ | async) {
      <div class="cache-warning-message">
        <i
          nz-icon
          nzType="exclamation-circle"
          nzTheme="twotone"
          [nzTwotoneColor]="'#FAAD14'"
        ></i>
        {{
          'sqtm-core.campaign-workspace.remote-issue.report-dialog.cache-warning'
            | translate
        }}
      </div>
    }
    <div class="p-10 full-height flex-grow-shrink">
      @if ((isOslcIssue$ | async) || !data.attachMode) {
        <div class="form-grid p-b-10">
          <sqtm-core-label
            [text]="
              'sqtm-core.campaign-workspace.remote-issue.report-dialog.remote-project.label'
                | translate
            "
          >
          </sqtm-core-label>
          <nz-select
            [nzOptions]="remoteProjectOptions"
            [ngModel]="currentRemoteProject"
            (ngModelChange)="handleProjectSelectChange($event)"
          >
          </nz-select>
        </div>
      }

      @if (!(remoteIssueService.loading$ | async)) {
        @if (!(isOslcIssue$ | async)) {
          @if (data.attachMode) {
            <sqtm-app-remote-issue-search
              [errorMessage]="searchErrorMessage$ | async"
              [foundRemoteIssue]="remoteIssueService.reportForm$ | async"
              [searchForm]="searchForm$ | async"
              (searchRequested)="searchForIssue($event)"
            >
            </sqtm-app-remote-issue-search>
          }
        }
        @if (remoteIssueService.reportForm$ | async) {
          @if (isOslcIssue$ | async) {
            <sqtm-app-new-oslc-issue-dialog
              [remoteIssueDialogState]="remoteIssueService.state$ | async"
              (requireDialogClose)="handleCloseOslc($event)"
            >
            </sqtm-app-new-oslc-issue-dialog>
          } @else {
            @if (isAdvancedIssue$ | async) {
              <sqtm-app-new-advanced-issue-form
                #advancedForm
                [remoteIssueDialogState]="remoteIssueService.state$ | async"
              >
              </sqtm-app-new-advanced-issue-form>
            } @else {
              <sqtm-app-new-remote-issue-form
                #btForm
                [remoteIssueDialogState]="remoteIssueService.state$ | async"
              >
              </sqtm-app-new-remote-issue-form>
            }
          }
        }
      } @else {
        @if (!(errorMessage$ | async)) {
          @if (shouldShowCacheTip$ | async) {
            <div>
              {{
                'sqtm-core.campaign-workspace.remote-issue.report-dialog.cache-tip'
                  | translate
              }}
            </div>
          }
          <div
            class="modal-overlay flex-row current-workspace-main-color table-icon-size"
          >
            <i nz-icon nzType="loading" nzTheme="outline" class="m-auto"></i>
          </div>
        }
      }

      @if (errorMessage$ | async; as message) {
        <div
          class="modal-overlay modal-overlay-error"
          [attr.data-test-element-id]="'modal-error-message'"
          (click)="errorOverlayClicked()"
        >
          <span class="m-auto">{{ message | translate }}</span>
        </div>
      }
    </div>
  </sqtm-core-dialog-body>
  <sqtm-core-dialog-footer>
    @if (!(isOslcIssue$ | async)) {
      @if (this.data.attachMode) {
        <button
          [attr.data-test-dialog-button-id]="'add-another'"
          class="flex-fixed-size m-l-10"
          nz-button
          nzType="primary"
          [disabled]="!(canConfirm$ | async)"
          (keyup)="consumeConfirmationEvent($event)"
          (click)="handleAddAnother()"
        >
          {{ 'sqtm-core.generic.label.add-another.feminine' | translate }}
        </button>
      }
      <button
        #submitButton
        [attr.data-test-element-id]="'confirm'"
        [attr.data-test-dialog-button-id]="'confirm'"
        class="flex-fixed-size m-l-10"
        nz-button
        nzType="primary"
        [disabled]="!(canConfirm$ | async)"
        (keyup)="consumeConfirmationEvent($event)"
        (click)="handleConfirmation()"
      >
        {{ 'sqtm-core.generic.label.add' | translate }}
      </button>
    }
    <button
      [attr.data-test-dialog-button-id]="'cancel'"
      class="flex-fixed-size m-l-10"
      nz-button
      nzType="default"
      sqtmCoreDialogClose
    >
      {{ 'sqtm-core.generic.label.cancel' | translate }}
    </button>
  </sqtm-core-dialog-footer>
</sqtm-core-customisable-dialog>
